%module md4rsa
%{
#include "md4.h"
#include <sys/cdefs.h>
%}
%include typemaps.i

%typemap(python,in) unsigned char *buffer {
    if (PyString_AsStringAndSize($source, &$target, buffer_length)==-1) {
        PyErr_SetString(PyExc_TypeError,"not a string type");
        return NULL; 
    }
}
%typemap(python,ignore) unsigned int length (unsigned int *buffer_length){
    buffer_length=&$target;
}

#define MD4_HASHBYTES  16
%typemap(python,argout) unsigned char sum[MD4_HASHBYTES] {
    PyObject *o=PyString_FromStringAndSize($source, MD4_HASHBYTES);
    $target = l_output_helper($target,o);
}
%typemap(python,ignore) unsigned char sum[MD4_HASHBYTES] {
    unsigned char temp_sum[MD4_HASHBYTES];
    $target=&temp_sum;
}

/* MD4 context. */
%name(md4) typedef struct MD4Context {
    %addmethods {
        MD4_CTX() {
            MD4_CTX *v;
            v = (MD4_CTX *)malloc(sizeof(MD4_CTX));
            MD4Init(v);
            return v;
        }
        ~MD4_CTX() {
            free(self);
        }
        void digest(unsigned char sum[MD4_HASHBYTES]) {
            MD4Final(sum,self);
        }
        void Update(unsigned char *buffer, unsigned int length) {
            MD4Update(self,buffer,length);
        }
        
    }
} MD4_CTX;

/*    
void   MD4Init(MD4_CTX *);
void   MD4Update(MD4_CTX *, const unsigned char *, unsigned int);
void   MD4Final(unsigned char [MD4_HASHBYTES], MD4_CTX *);
*/
